From cbe5ca0e2c70b4ae1ba2c146824517751b651aa0 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?=E5=A7=9C=E6=B5=B7=E5=A4=A9?= <1076168468@qq.com>
Date: Wed, 2 Nov 2022 19:04:48 +0800
Subject: [PATCH] =?UTF-8?q?=E4=BB=BB=E5=8A=A1=E5=AE=8C=E6=88=90=EF=BC=8C?=
 =?UTF-8?q?=E6=8F=90=E4=BA=A4=E4=BD=9C=E4=B8=9A?=
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

---
 block.c   | 69 ++++++++++++++++++++++++++++++++++++++++++++++---------
 sysproc.c | 14 +++++------
 2 files changed, 65 insertions(+), 18 deletions(-)

diff --git a/block.c b/block.c
index 4102969..0881585 100644
--- a/block.c
+++ b/block.c
@@ -387,6 +387,7 @@ ULONG SubQueueRemainLength = SUB_QUEUE_LENGTH;
 BOOL ScanInside = TRUE;
 
 
+
 PREQUEST
 IopDiskSchedule(
 	VOID
@@ -414,18 +415,64 @@ IopDiskSchedule(
 --*/
 {
 	PLIST_ENTRY pListEntry;
-	PREQUEST pNextRequest;
+	PREQUEST pRequest;
+	LONG Offset;
 	
-	//
-	// FCFS (First-Come,First-Served) ̵㷨һ򵥵Ĵ̵㷨
-	// ѡеĵһ󣬴Ӷ̷߳ʴ̵Ⱥ˳еȡ
-	//
-	pListEntry = RequestListHead.Next;	// еĵһͷָһ
+	ULONG InsideShortestDistance = 0xFFFFFFFF;
+	ULONG OutsideShortestDistance  = 0xFFFFFFFF;
+	PREQUEST pNextRequest[2] = { NULL , NULL };
 	
-	//
-	// ָ
-	//
-	pNextRequest = CONTAINING_RECORD(pListEntry, REQUEST, ListEntry);
+	static ULONG sub_queue_length = SUB_QUEUE_LENGTH;
+	if(0 == sub_queue_length){
+		sub_queue_length = SUB_QUEUE_LENGTH;
+	}
+	
+	ULONG i=sub_queue_length;
+	--sub_queue_length;
+	
+	for (pListEntry = RequestListHead.Next;	// еĵһͷָһ
+	     pListEntry != &RequestListHead && 0 != i;	// ͷʱѭ
+	     pListEntry = pListEntry->Next , --i) {
+	
+		//
+		// ָ
+		//
+		pRequest = CONTAINING_RECORD(pListEntry, REQUEST, ListEntry);
+		
+		//
+		// Ӧ߳ʵĴŵ뵱ǰͷڴŵƫƣʾ
+		//
+		Offset = pRequest->Cylinder - CurrentCylinder;
+		
+		if (0 == Offset) {
+			//
+			// ߳ҪʵĴŵ뵱ǰͷڴŵͬء
+			//
+			return pRequest;
+		} else if (Offset > 0) {
+			//
+			// ¼ƶ̵߳
+			//
+			if (Offset < InsideShortestDistance) {
+		
+				InsideShortestDistance = Offset;
+				pNextRequest[1] = pRequest;
+			}
+		} else if (Offset < 0) {
+			//
+			// ¼ƶ̵߳
+			//
+			if (-Offset < OutsideShortestDistance) {
+		
+				OutsideShortestDistance = -Offset;
+				pNextRequest[0] = pRequest;
+			}
+		}
+	}
+	
+	if(!pNextRequest[ScanInside]){
+		ScanInside=!ScanInside;
+	}
 	
-	return pNextRequest;
+	return pNextRequest[ScanInside];
 }
diff --git a/sysproc.c b/sysproc.c
index ba79659..c17123f 100644
--- a/sysproc.c
+++ b/sysproc.c
@@ -611,15 +611,15 @@ ConsoleCmdDiskSchedule(
 	// ʲͬŵ̡߳豸æЩ̵߳
 	// ᱻУ̵ֱ㷨ѡкŻᱻ
 	//
-	NewThreadAccessCylinder(StdHandle,  8);
-	NewThreadAccessCylinder(StdHandle, 21);
-	NewThreadAccessCylinder(StdHandle,  9);
 	NewThreadAccessCylinder(StdHandle, 78);
-	NewThreadAccessCylinder(StdHandle,  0);
-	NewThreadAccessCylinder(StdHandle, 41);
 	NewThreadAccessCylinder(StdHandle, 10);
-	NewThreadAccessCylinder(StdHandle, 67);
-	NewThreadAccessCylinder(StdHandle, 12);
+	NewThreadAccessCylinder(StdHandle, 10);
+	NewThreadAccessCylinder(StdHandle, 10);
+	NewThreadAccessCylinder(StdHandle, 10);
+	NewThreadAccessCylinder(StdHandle, 10);
+	NewThreadAccessCylinder(StdHandle, 10);
+	NewThreadAccessCylinder(StdHandle, 10);
+	NewThreadAccessCylinder(StdHandle, 10);
 	NewThreadAccessCylinder(StdHandle, 10);
 	
 	//
-- 
2.34.1.windows.1

